/*****************************************************************************\
 * Astro
 *
 * Astro     defines misc. handy constants & fns
 *
 * author: mark huss (mark@mhuss.com)
 *
\*****************************************************************************/

#if !defined( ASTRO__H )
#define ASTRO__H

#include <math.h>   // M_PI, etc.

// * * * * * Generic Handy Constants and Conversions * * * * *

// We do the static const member initializtion the "old-fashioned" way in
// Astro.cpp to get around problems with some compilers...

struct Astro {

  // day and time constants
  const static double HOURS_PER_DAY;
  const static double DAYS_PER_HOUR;   // 1 hr as a fractional day
  const static double SECONDS_PER_MINUTE;
  const static double MINUTES_PER_HOUR;
  const static double SECONDS_PER_HOUR;
  const static double MINUTES_PER_DAY;
  const static double SECONDS_PER_DAY;

  const static int    IHOURS_PER_DAY;
  const static int    ISECONDS_PER_MINUTE;
  const static int    IMINUTES_PER_HOUR;
  const static int    ISECONDS_PER_HOUR;

  // oft-used mathematical/circle constants
  const static double PI;
  const static double TWO_PI;
  const static double PI_OVER_TWO;
  const static double TWO_OVER_PI;

  const static double RAD_PER_CIRCLE;
  const static double DEG_PER_CIRCLE;
  const static double MINUTES_PER_DEGREE;
  const static double SECONDS_PER_DEGREE;
  const static double RADS_PER_DEGREE;

  // JD-related constants
  const static double DAYS_PER_CENTURY;
  const static double DAYS_PER_MILLENIUM;
  const static double JD_DIFF;
  const static double J2000;

  // misc.
  const static double ROUND;
  const static double INVALID;

};

#endif  /* #if !defined( ASTRO__H ) */

